	.file	"bar_trivial.c"
	.section	.debug_abbrev,"",@progbits
.Ldebug_abbrev0:
	.section	.debug_info,"",@progbits
.Ldebug_info0:
	.section	.debug_line,"",@progbits
.Ldebug_line0:
	.text
.Ltext0:
	.cfi_sections	.debug_frame
.globl x
	.bss
	.align 4
	.type	x, @object
	.size	x, 4
x:
	.zero	4
	.comm	bar,20,4
	.section	.rodata
.LC0:
	.string	"bar_trivial.c"
.LC1:
	.string	"r == 0 || r == -1"
	.text
.globl child_fn
	.type	child_fn, @function
child_fn:
.LFB0:
	.file 1 "bar_trivial.c"
	.loc 1 18 0
	.cfi_startproc
	pushl	%ebp
	.cfi_def_cfa_offset 8
	.cfi_offset 5, -8
	movl	%esp, %ebp
	.cfi_def_cfa_register 5
	subl	$40, %esp
	.loc 1 19 0
	movl	8(%ebp), %eax
	movl	%eax, -12(%ebp)
	.loc 1 21 0
	cmpl	$1, -12(%ebp)
	jne	.L2
	movl	x, %eax
	addl	$1, %eax
	movl	%eax, x
.L2:
	.loc 1 23 0
	movl	$bar, (%esp)
	call	pthread_barrier_wait
	movl	%eax, -16(%ebp)
	.loc 1 24 0
	cmpl	$0, -16(%ebp)
	je	.L3
	cmpl	$-1, -16(%ebp)
	je	.L3
	movl	$__PRETTY_FUNCTION__.3617, 12(%esp)
	movl	$24, 8(%esp)
	movl	$.LC0, 4(%esp)
	movl	$.LC1, (%esp)
	call	__assert_fail
.L3:
	.loc 1 26 0
	cmpl	$0, -12(%ebp)
	jne	.L4
	movl	x, %eax
	addl	$1, %eax
	movl	%eax, x
.L4:
	.loc 1 28 0
	movl	$1, (%esp)
	call	sleep
	.loc 1 30 0
	movl	$0, %eax
	.loc 1 31 0
	leave
	.cfi_restore 5
	.cfi_def_cfa 4, 4
	ret
	.cfi_endproc
.LFE0:
	.size	child_fn, .-child_fn
	.section	.rodata
.LC2:
	.string	"!r"
.LC3:
	.string	"x = %d\n"
	.text
.globl main
	.type	main, @function
main:
.LFB1:
	.loc 1 36 0
	.cfi_startproc
	pushl	%ebp
	.cfi_def_cfa_offset 8
	.cfi_offset 5, -8
	movl	%esp, %ebp
	.cfi_def_cfa_register 5
	andl	$-16, %esp
	subl	$32, %esp
	.loc 1 40 0
	movl	$2, 8(%esp)
	movl	$0, 4(%esp)
	movl	$bar, (%esp)
	call	pthread_barrier_init
	movl	%eax, 28(%esp)
	.loc 1 41 0
	cmpl	$0, 28(%esp)
	je	.L7
	movl	$__PRETTY_FUNCTION__.3638, 12(%esp)
	movl	$41, 8(%esp)
	movl	$.LC0, 4(%esp)
	movl	$.LC2, (%esp)
	call	__assert_fail
.L7:
	.loc 1 43 0
	movl	$0, 24(%esp)
	jmp	.L8
.L10:
	.loc 1 44 0
	movl	24(%esp), %edx
	movl	24(%esp), %eax
	leal	0(,%eax,4), %ecx
	leal	16(%esp), %eax
	addl	%ecx, %eax
	movl	%edx, 12(%esp)
	movl	$child_fn, 8(%esp)
	movl	$0, 4(%esp)
	movl	%eax, (%esp)
	call	pthread_create
	movl	%eax, 28(%esp)
	.loc 1 45 0
	cmpl	$0, 28(%esp)
	je	.L9
	movl	$__PRETTY_FUNCTION__.3638, 12(%esp)
	movl	$45, 8(%esp)
	movl	$.LC0, 4(%esp)
	movl	$.LC2, (%esp)
	call	__assert_fail
.L9:
	.loc 1 43 0
	addl	$1, 24(%esp)
.L8:
	cmpl	$1, 24(%esp)
	jle	.L10
	.loc 1 48 0
	movl	$0, 24(%esp)
	jmp	.L11
.L13:
	.loc 1 49 0
	movl	24(%esp), %eax
	movl	16(%esp,%eax,4), %eax
	movl	$0, 4(%esp)
	movl	%eax, (%esp)
	call	pthread_join
	movl	%eax, 28(%esp)
	.loc 1 50 0
	cmpl	$0, 28(%esp)
	je	.L12
	movl	$__PRETTY_FUNCTION__.3638, 12(%esp)
	movl	$50, 8(%esp)
	movl	$.LC0, 4(%esp)
	movl	$.LC2, (%esp)
	call	__assert_fail
.L12:
	.loc 1 48 0
	addl	$1, 24(%esp)
.L11:
	cmpl	$1, 24(%esp)
	jle	.L13
	.loc 1 53 0
	movl	$bar, (%esp)
	call	pthread_barrier_destroy
	movl	%eax, 28(%esp)
	cmpl	$0, 28(%esp)
	je	.L14
	movl	$__PRETTY_FUNCTION__.3638, 12(%esp)
	movl	$53, 8(%esp)
	movl	$.LC0, 4(%esp)
	movl	$.LC2, (%esp)
	call	__assert_fail
.L14:
	.loc 1 55 0
	movl	x, %edx
	movl	$.LC3, %eax
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	printf
	.loc 1 56 0
	movl	$0, %eax
	.loc 1 57 0
	leave
	.cfi_restore 5
	.cfi_def_cfa 4, 4
	ret
	.cfi_endproc
.LFE1:
	.size	main, .-main
	.section	.rodata
	.type	__PRETTY_FUNCTION__.3638, @object
	.size	__PRETTY_FUNCTION__.3638, 5
__PRETTY_FUNCTION__.3638:
	.string	"main"
	.type	__PRETTY_FUNCTION__.3617, @object
	.size	__PRETTY_FUNCTION__.3617, 9
__PRETTY_FUNCTION__.3617:
	.string	"child_fn"
	.text
.Letext0:
	.file 2 "/usr/include/bits/pthreadtypes.h"
	.section	.debug_info
	.long	0x1ce
	.value	0x3
	.long	.Ldebug_abbrev0
	.byte	0x4
	.uleb128 0x1
	.long	.LASF17
	.byte	0x1
	.long	.LASF18
	.long	.LASF19
	.long	.Ltext0
	.long	.Letext0
	.long	.Ldebug_line0
	.uleb128 0x2
	.byte	0x1
	.byte	0x8
	.long	.LASF0
	.uleb128 0x2
	.byte	0x2
	.byte	0x7
	.long	.LASF1
	.uleb128 0x2
	.byte	0x4
	.byte	0x7
	.long	.LASF2
	.uleb128 0x2
	.byte	0x4
	.byte	0x7
	.long	.LASF3
	.uleb128 0x2
	.byte	0x1
	.byte	0x6
	.long	.LASF4
	.uleb128 0x2
	.byte	0x2
	.byte	0x5
	.long	.LASF5
	.uleb128 0x3
	.byte	0x4
	.byte	0x5
	.string	"int"
	.uleb128 0x2
	.byte	0x8
	.byte	0x5
	.long	.LASF6
	.uleb128 0x2
	.byte	0x8
	.byte	0x7
	.long	.LASF7
	.uleb128 0x2
	.byte	0x4
	.byte	0x5
	.long	.LASF8
	.uleb128 0x4
	.byte	0x4
	.uleb128 0x2
	.byte	0x1
	.byte	0x6
	.long	.LASF9
	.uleb128 0x5
	.long	.LASF12
	.byte	0x2
	.byte	0x24
	.long	0x3a
	.uleb128 0x6
	.byte	0x14
	.byte	0x2
	.byte	0x9d
	.long	0x9e
	.uleb128 0x7
	.long	.LASF10
	.byte	0x2
	.byte	0x9e
	.long	0x9e
	.uleb128 0x7
	.long	.LASF11
	.byte	0x2
	.byte	0x9f
	.long	0x64
	.byte	0x0
	.uleb128 0x8
	.long	0x6d
	.long	0xae
	.uleb128 0x9
	.long	0x33
	.byte	0x13
	.byte	0x0
	.uleb128 0x5
	.long	.LASF13
	.byte	0x2
	.byte	0xa0
	.long	0x7f
	.uleb128 0xa
	.byte	0x1
	.long	.LASF14
	.byte	0x1
	.byte	0x11
	.byte	0x1
	.long	0x6b
	.long	.LFB0
	.long	.LFE0
	.byte	0x1
	.byte	0x9c
	.long	0x10b
	.uleb128 0xb
	.string	"arg"
	.byte	0x1
	.byte	0x11
	.long	0x6b
	.byte	0x2
	.byte	0x91
	.sleb128 0
	.uleb128 0xc
	.string	"r"
	.byte	0x1
	.byte	0x13
	.long	0x64
	.byte	0x2
	.byte	0x91
	.sleb128 -24
	.uleb128 0xc
	.string	"n"
	.byte	0x1
	.byte	0x13
	.long	0x64
	.byte	0x2
	.byte	0x91
	.sleb128 -20
	.uleb128 0xd
	.long	.LASF16
	.long	0x11b
	.byte	0x1
	.byte	0x5
	.byte	0x3
	.long	__PRETTY_FUNCTION__.3617
	.byte	0x0
	.uleb128 0x8
	.long	0x6d
	.long	0x11b
	.uleb128 0x9
	.long	0x33
	.byte	0x8
	.byte	0x0
	.uleb128 0xe
	.long	0x10b
	.uleb128 0xa
	.byte	0x1
	.long	.LASF15
	.byte	0x1
	.byte	0x23
	.byte	0x1
	.long	0x4f
	.long	.LFB1
	.long	.LFE1
	.byte	0x1
	.byte	0x9c
	.long	0x172
	.uleb128 0xc
	.string	"i"
	.byte	0x1
	.byte	0x25
	.long	0x64
	.byte	0x2
	.byte	0x74
	.sleb128 24
	.uleb128 0xc
	.string	"r"
	.byte	0x1
	.byte	0x25
	.long	0x64
	.byte	0x2
	.byte	0x74
	.sleb128 28
	.uleb128 0xc
	.string	"thr"
	.byte	0x1
	.byte	0x26
	.long	0x172
	.byte	0x2
	.byte	0x74
	.sleb128 16
	.uleb128 0xd
	.long	.LASF16
	.long	0x192
	.byte	0x1
	.byte	0x5
	.byte	0x3
	.long	__PRETTY_FUNCTION__.3638
	.byte	0x0
	.uleb128 0x8
	.long	0x74
	.long	0x182
	.uleb128 0x9
	.long	0x33
	.byte	0x1
	.byte	0x0
	.uleb128 0x8
	.long	0x6d
	.long	0x192
	.uleb128 0x9
	.long	0x33
	.byte	0x4
	.byte	0x0
	.uleb128 0xe
	.long	0x182
	.uleb128 0xf
	.string	"x"
	.byte	0x1
	.byte	0xd
	.long	0x4f
	.byte	0x1
	.byte	0x1
	.uleb128 0xf
	.string	"bar"
	.byte	0x1
	.byte	0xf
	.long	0xae
	.byte	0x1
	.byte	0x1
	.uleb128 0x10
	.string	"x"
	.byte	0x1
	.byte	0xd
	.long	0x4f
	.byte	0x1
	.byte	0x5
	.byte	0x3
	.long	x
	.uleb128 0x10
	.string	"bar"
	.byte	0x1
	.byte	0xf
	.long	0xae
	.byte	0x1
	.byte	0x5
	.byte	0x3
	.long	bar
	.byte	0x0
	.section	.debug_abbrev
	.uleb128 0x1
	.uleb128 0x11
	.byte	0x1
	.uleb128 0x25
	.uleb128 0xe
	.uleb128 0x13
	.uleb128 0xb
	.uleb128 0x3
	.uleb128 0xe
	.uleb128 0x1b
	.uleb128 0xe
	.uleb128 0x11
	.uleb128 0x1
	.uleb128 0x12
	.uleb128 0x1
	.uleb128 0x10
	.uleb128 0x6
	.byte	0x0
	.byte	0x0
	.uleb128 0x2
	.uleb128 0x24
	.byte	0x0
	.uleb128 0xb
	.uleb128 0xb
	.uleb128 0x3e
	.uleb128 0xb
	.uleb128 0x3
	.uleb128 0xe
	.byte	0x0
	.byte	0x0
	.uleb128 0x3
	.uleb128 0x24
	.byte	0x0
	.uleb128 0xb
	.uleb128 0xb
	.uleb128 0x3e
	.uleb128 0xb
	.uleb128 0x3
	.uleb128 0x8
	.byte	0x0
	.byte	0x0
	.uleb128 0x4
	.uleb128 0xf
	.byte	0x0
	.uleb128 0xb
	.uleb128 0xb
	.byte	0x0
	.byte	0x0
	.uleb128 0x5
	.uleb128 0x16
	.byte	0x0
	.uleb128 0x3
	.uleb128 0xe
	.uleb128 0x3a
	.uleb128 0xb
	.uleb128 0x3b
	.uleb128 0xb
	.uleb128 0x49
	.uleb128 0x13
	.byte	0x0
	.byte	0x0
	.uleb128 0x6
	.uleb128 0x17
	.byte	0x1
	.uleb128 0xb
	.uleb128 0xb
	.uleb128 0x3a
	.uleb128 0xb
	.uleb128 0x3b
	.uleb128 0xb
	.uleb128 0x1
	.uleb128 0x13
	.byte	0x0
	.byte	0x0
	.uleb128 0x7
	.uleb128 0xd
	.byte	0x0
	.uleb128 0x3
	.uleb128 0xe
	.uleb128 0x3a
	.uleb128 0xb
	.uleb128 0x3b
	.uleb128 0xb
	.uleb128 0x49
	.uleb128 0x13
	.byte	0x0
	.byte	0x0
	.uleb128 0x8
	.uleb128 0x1
	.byte	0x1
	.uleb128 0x49
	.uleb128 0x13
	.uleb128 0x1
	.uleb128 0x13
	.byte	0x0
	.byte	0x0
	.uleb128 0x9
	.uleb128 0x21
	.byte	0x0
	.uleb128 0x49
	.uleb128 0x13
	.uleb128 0x2f
	.uleb128 0xb
	.byte	0x0
	.byte	0x0
	.uleb128 0xa
	.uleb128 0x2e
	.byte	0x1
	.uleb128 0x3f
	.uleb128 0xc
	.uleb128 0x3
	.uleb128 0xe
	.uleb128 0x3a
	.uleb128 0xb
	.uleb128 0x3b
	.uleb128 0xb
	.uleb128 0x27
	.uleb128 0xc
	.uleb128 0x49
	.uleb128 0x13
	.uleb128 0x11
	.uleb128 0x1
	.uleb128 0x12
	.uleb128 0x1
	.uleb128 0x40
	.uleb128 0xa
	.uleb128 0x1
	.uleb128 0x13
	.byte	0x0
	.byte	0x0
	.uleb128 0xb
	.uleb128 0x5
	.byte	0x0
	.uleb128 0x3
	.uleb128 0x8
	.uleb128 0x3a
	.uleb128 0xb
	.uleb128 0x3b
	.uleb128 0xb
	.uleb128 0x49
	.uleb128 0x13
	.uleb128 0x2
	.uleb128 0xa
	.byte	0x0
	.byte	0x0
	.uleb128 0xc
	.uleb128 0x34
	.byte	0x0
	.uleb128 0x3
	.uleb128 0x8
	.uleb128 0x3a
	.uleb128 0xb
	.uleb128 0x3b
	.uleb128 0xb
	.uleb128 0x49
	.uleb128 0x13
	.uleb128 0x2
	.uleb128 0xa
	.byte	0x0
	.byte	0x0
	.uleb128 0xd
	.uleb128 0x34
	.byte	0x0
	.uleb128 0x3
	.uleb128 0xe
	.uleb128 0x49
	.uleb128 0x13
	.uleb128 0x34
	.uleb128 0xc
	.uleb128 0x2
	.uleb128 0xa
	.byte	0x0
	.byte	0x0
	.uleb128 0xe
	.uleb128 0x26
	.byte	0x0
	.uleb128 0x49
	.uleb128 0x13
	.byte	0x0
	.byte	0x0
	.uleb128 0xf
	.uleb128 0x34
	.byte	0x0
	.uleb128 0x3
	.uleb128 0x8
	.uleb128 0x3a
	.uleb128 0xb
	.uleb128 0x3b
	.uleb128 0xb
	.uleb128 0x49
	.uleb128 0x13
	.uleb128 0x3f
	.uleb128 0xc
	.uleb128 0x3c
	.uleb128 0xc
	.byte	0x0
	.byte	0x0
	.uleb128 0x10
	.uleb128 0x34
	.byte	0x0
	.uleb128 0x3
	.uleb128 0x8
	.uleb128 0x3a
	.uleb128 0xb
	.uleb128 0x3b
	.uleb128 0xb
	.uleb128 0x49
	.uleb128 0x13
	.uleb128 0x3f
	.uleb128 0xc
	.uleb128 0x2
	.uleb128 0xa
	.byte	0x0
	.byte	0x0
	.byte	0x0
	.section	.debug_pubnames,"",@progbits
	.long	0x32
	.value	0x2
	.long	.Ldebug_info0
	.long	0x1d2
	.long	0xb9
	.string	"child_fn"
	.long	0x120
	.string	"main"
	.long	0x1af
	.string	"x"
	.long	0x1bf
	.string	"bar"
	.long	0x0
	.section	.debug_pubtypes,"",@progbits
	.long	0x32
	.value	0x2
	.long	.Ldebug_info0
	.long	0x1d2
	.long	0x74
	.string	"pthread_t"
	.long	0xae
	.string	"pthread_barrier_t"
	.long	0x0
	.section	.debug_aranges,"",@progbits
	.long	0x1c
	.value	0x2
	.long	.Ldebug_info0
	.byte	0x4
	.byte	0x0
	.value	0x0
	.value	0x0
	.long	.Ltext0
	.long	.Letext0-.Ltext0
	.long	0x0
	.long	0x0
	.section	.debug_str,"MS",@progbits,1
.LASF6:
	.string	"long long int"
.LASF17:
	.string	"GNU C 4.4.5 20101112 (Red Hat 4.4.5-2)"
.LASF2:
	.string	"unsigned int"
.LASF15:
	.string	"main"
.LASF19:
	.string	"/root/genprog-many-bugs/valgrind-bug-12474-12475/valgrind/helgrind/tests"
.LASF3:
	.string	"long unsigned int"
.LASF7:
	.string	"long long unsigned int"
.LASF18:
	.string	"bar_trivial.c"
.LASF0:
	.string	"unsigned char"
.LASF9:
	.string	"char"
.LASF13:
	.string	"pthread_barrier_t"
.LASF8:
	.string	"long int"
.LASF10:
	.string	"__size"
.LASF1:
	.string	"short unsigned int"
.LASF4:
	.string	"signed char"
.LASF16:
	.string	"__PRETTY_FUNCTION__"
.LASF14:
	.string	"child_fn"
.LASF11:
	.string	"__align"
.LASF5:
	.string	"short int"
.LASF12:
	.string	"pthread_t"
	.ident	"GCC: (GNU) 4.4.5 20101112 (Red Hat 4.4.5-2)"
	.section	.note.GNU-stack,"",@progbits
